# -*- coding: utf-8 -*-

from twootr import web, render
from twootr.core import Core

class index(Core):
	def GET(self):
		user = self.get_logged_user()
		twoots = self.get_twoots()
		twoots = self.decorate_twoots(twoots)
		
		return self.base(render.index(user, twoots, useWebSafe=False))

class user(Core):
	def GET(self, nick):
		me = self.get_logged_user()
		user = self.get_user(nick)
		
		if user:
			friendship = False
			if me:
				if user.id == me.id:
					# same user, just display its home.
					return self.redirect("/home/")
				else:
					friendship = self.is_friend_with(me, user)
			
			twoots = self.get_twoots(user, with_friends=False)
			twoots = self.decorate_twoots(twoots)
			
			return self.base(render.user(user, twoots, friendship))
		else:
			# the selected user doesn't exist
			return self.epic_fail()

class status(Core):
	def GET(self, nick, twoot_id):
		me = self.get_logged_user()	
		user = self.get_user(nick)
		
		if user:
			twoot = self.get_twoot_by_id(twoot_id, user)
			web.debug(twoot)
			if twoot:
				friendship = False
				if me and user.id != me.id:
					friendship = self.is_friend_with(me, user)
				
				twoot = self.decorate_twoot(twoot)
				
				return self.base(render.twoot(user, twoot, friendship))
			else:
				return self.epic_fail()
		else:
			return self.epic_fail()

class home(Core):
	def GET(self):
		user = self.get_logged_user()
		
		if user:
			twoots = self.get_twoots(user, with_friends=True)
			twoots = self.decorate_twoots(twoots)
			
			return self.base(render.home(user, twoots))
		else:
			return self.epic_fail()
	
	def POST(self):
		user = self.get_logged_user()
		if user:
			inputs = web.input()
				
			if "status" in inputs:
				self.post_twoot(user, inputs.status)
				self.send_notifications(user, inputs.status.decode("utf-8"))
			return self.go_home()
		else:
			return self.epic_fail()

class ajax(Core):
	def POST(self):
		inputs = web.input()
		if "id" in inputs:
			last_id = int(inputs.id)
			if "user" in inputs:
				if inputs.user == "home":
					user = self.get_logged_user()
				else:
					user = self.get_user(inputs.user)
				
				if user:
					twoots = self.get_twoots(user, last_id=last_id)
			else:
				twoots = self.get_twoots(last_id=last_id)
		
		if twoots:
			twoots = self.decorate_twoots(twoots)
			self.json(twoots)
		else:
			# TODO: return a 304 Not Modified
			# in order to save bandwidth.
			self.json([])
	
	# You'd better use curl to debug
	#GET = POST
